function Prato($scope, $interval, ApplicationContext, ScreenService, MessageService) {
    var sf = $scope;
    let qtde = getLocalVar('language') == 'pt_br' ? 'Qtde' : 'Quantidade';
    $scope.dataStripe = [
       {
           PRATO: ScreenService.i18n('Prato'),
           QTDE: ScreenService.i18n(qtde),
           SIT: ScreenService.i18n('Situação'),
           DURA: ScreenService.i18n('Duração')
       }
    ];
    
    $scope.$watch(() => $scope.widget.dataSource.data, () => {
        $scope.onEnter();
        $scope.pointActivate = 1;
    }, true);
    
    window.addEventListener("resize", () => $scope.onEnter(), false);
    
    //Cria um array com os elementos da tela para cada prato.
    $scope.onEnter = function(){
        $scope.arrayPrato = [];
        let arrayProvisorio = [];
        let numElemento = Math.round(document.querySelector('.painel').offsetHeight / getScreenWidth()) - 1;
        let withoutImg = './../mobile/assets/modules/cardapio/assets/templates/img/withoutImg.png';
        
        $scope.widget.dataSource.data.forEach((element) => {
            let foto = null;
            
            if(element.URL_FOTOPRATO != null){
                foto = element.URL_FOTOPRATO;
            }else if (element.BLOB_FOTOPRATO != null){
                foto = 'data:image/png;base64, ' + element.BLOB_FOTOPRATO;
            }
            
            
            if(element.HORA_INI != '00:00'){
                let object = {
                    IDCONFIRMPLAN: element.IDCONFIRMPLAN,
                    IDBLOQPROD: element.IDBLOQPROD,
                    NRORG: element.NRORG,
                    NRPRODCADENCI: element.NRPRODCADENCI,
                    CDSERVFILI: element.CDSERVFILI,
                    CDFILIAL: element.CDFILIAL,
                    CDPRATO: element.CDPRATO,
                    NMPRATO: element.NMPRATO,
                    HRINICATEN: formatHour(element.HRINICATEN),
                    HRINICSERV: element.HRINICSERV,
                    HRFINASERV: formatHour(element.HRFINASERV),
                    HORA_INI: formatHour(element.HORA_INI),
                    HORA_FIM: formatHour(element.HORA_FIM),
                    DURACAOFIX: formatHour(element.DURACAO),
                    DURACAO: verificaHoras(element),
                    SGUNIDADE: element.SGUNIDADE,
                    QUANTIDADE: parseFloat(element.QUANTIDADE).toFixed(5),
                    IDSTATUS: element.IDSTATUS,
                    INIPREPREAL: formatHour(element.INIPREPREAL),
                    FIMPREPREAL: formatHour(element.FIMPREPREAL),
                    DESCRICAO: defineSituacao(element.IDSTATUS),
                    FOTOSRC: foto == null ? withoutImg : foto,
                    LEFT: 0,
                    WIDTH: 0
                };
                
                if(emAndamento(object.IDSTATUS)) iniciaTempo(object);
                if(arrayProvisorio.length == numElemento){
                  $scope.arrayPrato.push(arrayProvisorio);
                  arrayProvisorio = [];
                }
                calcTimeline(object);
                arrayProvisorio.push(object);
            }
        });
        
        if($scope.arrayPrato.length < ($scope.widget.dataSource.data.length / numElemento)) $scope.arrayPrato.push(arrayProvisorio);
    };
    
    function getScreenWidth(){
      let resolution = screen.width;
      if(resolution >= 1824) return 110;
      else if(resolution >= 1025) return 85;
      else if(resolution == 1024) return 74;
      else if(resolution >= 768) return 60;
    }
    
    // Verifica a situação do prato e se o tempo de finalização é maior do que a de inicialização
    $scope.saveStatus = function(prato){
        statusPrato(prato);
        if(prato.IDSTATUS == 'C' && prato.FIMPREPREAL.format('HH:mm') == "00:00"){
            if(moment().format('HH:mm') >= prato.INIPREPREAL.format('HH:mm')){
                let config = {
                    type: "question",
    				icon: "question",
    				success:  function(){
    				    if(prato.intervalTempo) destroyTimer(prato.intervalTempo);
    				    if(prato.cronometro){
    			            prato.MINUS = false;
                            prato.MINSYMBOL = "";
                            destroyTimer(prato.cronometro);	        
    				    }
                        save(prato);
    				},
    				fail: function(){
    				    prato.IDSTATUS = mudaStatus('P');
                        prato.DESCRICAO = defineSituacao(prato.IDSTATUS);
    				}
                };
                
                MessageService.confirmMessageByCode('confirmConclusaoPainel', {NMPRATO: prato.NMPRATO}, config);    
            }else{
                MessageService.showMessageByCode("MSG_ERROR_FINALIZACAOPRAT", null, Constants.errorMessage);
                prato.IDSTATUS = mudaStatus('P');
                prato.DESCRICAO = defineSituacao(prato.IDSTATUS);
            }
        }else if(prato.IDSTATUS != 'C'){
            save(prato);
            iniciaTempo(prato);
        }
    };
    
    $scope.checarAtrasso = function(){
        let pratos = sf.arrayPrato;
        if(pratos){
            setInterval(() => {
                pratos.forEach((prato) => {atrassado(prato);});
            });
        }
    };
    
    $scope.nextSlide = function(index){
        let largChild = document.querySelector('.carousel div').offsetWidth;
        let largChildTimeLine = document.querySelector('.carousel-timeline div').offsetWidth;
        document.querySelector('.carousel').scrollLeft = ((largChild * index) - largChild );
        document.querySelector('.carousel-timeline').scrollLeft = ((largChildTimeLine * index) - largChildTimeLine );
        changeColorPointAction(index);
        $scope.pointActivate = index;
    };
    
    $scope.markFirstColorPointAction = function(){
        let points = document.getElementsByClassName('points');
        if(points[0]){
            points[0].classList.add("pointActive");
        }
    };
    
    function changeColorPointAction(index){
        let points = document.getElementsByClassName('points');
        let choosen = document.getElementById('point-index-' + index);
        [].forEach.call(points, (point) => {point.classList.remove("pointActive");});
        choosen.classList.add("pointActive");
    }
    
    $scope.slideAutomatico = function(){
        $scope.intervalSlide = setInterval(() =>{
            let index = 1;
            if($scope.arrayPrato.length != $scope.pointActivate) index = $scope.pointActivate + 1;
            $scope.nextSlide(index);
        }, 60000);
    };
    
    function save(prato){
        let changeStatus = $scope.widget.actions.find(act=>act.changeStatus);
        $scope.$eval(changeStatus.onClick, Object.assign({
            'prato': prato
        }, ApplicationContext));
    }
    
    function formatHour(hour){
      if(hour){
          hour = hour.replace(':', '');
          return moment().hours(hour.substr(0,2)).minutes(hour.substr(2,2)).seconds('00');
      }
    }
    
    function calcTimeline(object){
        let percentIni = ((object.HORA_INI.valueOf() - object.HRINICATEN.valueOf()) * 100) / (object.HRFINASERV.valueOf() - object.HRINICATEN.valueOf());
        let percentFim = ((object.HORA_FIM.valueOf() - object.HRINICATEN.valueOf()) * 100) / (object.HRFINASERV.valueOf() - object.HRINICATEN.valueOf());
        percentFim = percentFim - percentIni;
        object.LEFT = percentIni.toFixed(1) + '%';
        object.WIDTH = percentFim.toFixed(1) + '%';
    }
    
    // Manipula o status do prato.
    function statusPrato(prato){
        prato.IDSTATUS = mudaStatus(prato.IDSTATUS);
        prato.DESCRICAO = defineSituacao(prato.IDSTATUS);
    }
    
    // Define qual nome da situação;
    function defineSituacao(status){
        if(status == 'P'){
            return  ScreenService.i18n('Pendente');
        }else if(status == 'A'){
            return ScreenService.i18n('Andamento');
        }else if(status == 'C'){
            return  ScreenService.i18n('Concluído');
        }else{
            return  ScreenService.i18n('Reposição');
        }
    }
    
    // Modifica o situação para a proxima.
    function mudaStatus(status){
        if(status == 'P'){
            return 'A';
        }else if(status == 'A'){
            return 'C';
        }else{
            return 'C';
        }
    }
    
    //Cronometro Regressivo.
    function iniciaTempo(prato){
        prato.intervalTempo = setInterval(() => {
            var tempoAndamento = moment();
            decreaseTime(tempoAndamento, prato.INIPREPREAL);
            if(tempoUltrapassado(prato.DURACAOFIX, tempoAndamento)){
                destroyTimer(prato.intervalTempo);
                cronometro(prato);
                prato.MINUS = true;
                prato.MINSYMBOL = "-";
            }else{
                prato.DURACAO.subtract('seconds', 1);
                $scope.$apply();
            }
        }, 1000);
    }
    
    function cronometro(prato){
        prato.cronometro = setInterval(() => {
            prato.DURACAO.add('seconds', 1);
            $scope.$apply();
        }, 1000);    
    }
    
    function destroyTimer(intervalo){
        clearInterval(intervalo);
    }
    
    function emAndamento(status){
        if(status == 'A') return true;
        else return false;
    }
    
    // Ao iniciar a tela, verifica em qual status e tempo o prato parou.
    function verificaHoras(element){
        let duracao = formatHour(element.DURACAO);
        let horaInicial;
        if(emAndamento(element.IDSTATUS)){
            var tempoAndamento = moment();
            horaInicial = formatHour(element.INIPREPREAL);
            decreaseTime(tempoAndamento, horaInicial);
            
            if(tempoUltrapassado(duracao, tempoAndamento)){
                decreaseTime(tempoAndamento, duracao);
                return tempoAndamento;
            }
            else decreaseTime(duracao, tempoAndamento);
        }else if(element.IDSTATUS == 'C'){
            horaInicial = formatHour(element.INIPREPREAL);
            var horaFinal = formatHour(element.FIMPREPREAL);
            
            decreaseTime(horaFinal, horaInicial);
            return horaFinal;
        }
        
        return duracao;
    }
    
    function decreaseTime(timeDecrease, time){
        timeDecrease.subtract('minutes', time.minutes());
        timeDecrease.subtract('hours', time.hours());
    }
    
    function tempoUltrapassado(duracao, tempo){
        if(duracao.format('HH:mm') <= tempo.format('HH:mm')) return true;
        else return false;
    }
    
    function atrassado(pratos){
        pratos.forEach(function(prato){
            if(prato.IDSTATUS == 'P'){
                let horaAtual = moment();
                if(prato.HORA_INI.format('HH:mm') <= horaAtual.format('HH:mm'))
                    prato.ATRASSADO = true;
                else 
                    prato.ATRASSADO = false;
            }else if(emAndamento(prato.IDSTATUS)){
                var tempoAndamento = moment();
                decreaseTime(tempoAndamento, prato.INIPREPREAL);
                
                if(tempoUltrapassado(prato.DURACAOFIX, tempoAndamento)) 
                    prato.ATRASSADO = true;
                else 
                    prato.ATRASSADO = false;
            }else{
                prato.ATRASSADO = false;
            }
        });
    }
}